#
#       HBS REDUCTION SUB ROUTINE
#
#       Fit polynomial and smoothing Flat Images : hbsflatfit.cl
#
#
procedure hbsflatfit

begin

  string infn[200], outfn[200]
  int i, n_list
  file fn1, fn2, tmp_fn1, tmp_fn2
  string buf
#  int y1_2HL = 14  # TI 2holes
#  int y2_2HL = 78
#  int y1_2S2 = 16  # TI 2slit02
#  int y2_2S2 = 76

#  int y1_2HL =  9  # SITe 2holes
#  int y2_2HL = 40 
#  int y1_2S2 = 7  # SITe 2slit02
#  int y2_2S2 = 40 

#  int y1_2HL = 10  # Andor 2holes
#  int y2_2HL = 78 
#  int y1_2S2 = 10  # Andor 2slit02
#  int y2_2S2 = 78 

# for 0510cal, Andor
  int y1_2HL = 11  # Andor 2holes
  int y2_2HL = 78 
  int y1_2S2 = 11  # Andor 2slit02
  int y2_2S2 = 78 
  int y1, y2
  int dy, ymid
  file inlist
  file outlist

  tmp_fn1 = "hbs.tmp.fn1"
  tmp_fn2 = "hbs.tmp.fn2"
  inlist = mktemp( "hbs.tmp.list." )
  outlist = mktemp( "hbs.tmp.list." )

  sections( "FLAT.*.sf.?.imh", option="fullname", >> inlist )
  sed( 's/\.sf\./\.ft\./', inlist, > outlist )

  n_list = 0
  list = inlist
  while( fscan( list, buf ) != EOF )
  {
    n_list += 1
    infn[n_list] = buf
  }
  delete( inlist, ver- )

  list = outlist
  for( i=1; i<=n_list; i+=1 )
  {
    if( fscan( list, buf ) != 1 )
    {
      printf( "File conversion error. Check list-file." )
      bye
    }
    outfn[i] = buf
  }
  delete( outlist, ver- )

  for( i=1; i<=n_list; i+=1 )
  {
    fn1 = infn[i]
    fn2 = outfn[i]

    if( access( fn1 ) == 0 )
    {
      printf( "'%s' not found.\n", fn1 )
      return
    }

    if( access( tmp_fn1//".imh" ) == 1 )
      imdelete( tmp_fn1, ver- )
    if( access( tmp_fn2//".imh" ) == 1 )
      imdelete( tmp_fn2, ver- )
    if( access( fn2 ) == 1 )
      imdelete( fn2, ver- )

    imgets( fn1, 'i_naxis2' )
    dy = int( imgets.value )
    ymid = dy / 2

    y1 = 0
    y2 = 0

    imgets( fn1, "DIAPHRAG" )
    buf = imgets.value
    if( substr( buf, 1, 6 ) == "2HOLES" )
    {
      y1 = y1_2HL
      y2 = y2_2HL
    }
    if( substr( buf, 1, 7 ) == "2SLIT02" )
    {
      y1 = y1_2S2
      y2 = y2_2S2
    }

    if( y1*y2 == 0 )
    {
      printf( "Unknown DIAPHRAG type (%s). Skip.\n", buf )
      next
    }

    background( fn1, tmp_fn1, axis=2, interactive+,\
                sample=y1//":"//y2, naverage=3, function="legendre",\
		order=3, cursor="" )
    imarith( fn1, "-", tmp_fn1, fn2, pixtype="real",\
             calctype="real", ver- )
    imdelete( tmp_fn1, ver- )

    imcopy( fn2//"[*,"//ymid//":"//ymid//"]", tmp_fn1, ver- )
    imstack( tmp_fn1, tmp_fn2 )
    imdelete( tmp_fn1, ver- )
    blkrep( tmp_fn2, tmp_fn2, 1, dy )

    imarith( fn2, "/", tmp_fn2, fn2, pixtype="real",\
             calctype="real", ver- )
    imdelete( tmp_fn2, ver- )
  }

end
