#
#       HBS REDUCTION SUB ROUTINE
#
#      Fit polynomial functions : hbsprefit.cl
#
#       1997/07/01      K.Kawabata  Ver.0.30  for original fitting
#


procedure hbsprefit


begin

  file infn, tmp_tbl
  file outfn = "hbsprefit.dat"
  int i, j
  string buf = ""
  string buf1, buf2, buf3, buf4, buf5, buf6, buf7
  real c[6]

  tmp_tbl = mktemp( "hbs.tmp.tbl." )


  print( "" )
  print( "----------------------------------" )
  print( " fit template-curvature functions" )
  print( "----------------------------------" )
  print( "" )

  if( access( tmp_tbl ) == 1 )
    delete( tmp_tbl, ver- )

  if( access( outfn ) == 1 )
    delete( outfn, ver- )

#---- search plot files

  for( i=1; i<=4; i+=1 )
  {
    infn = "hbsprescan."//i
    if( access( infn ) == 0 )
    {
      print( "cannnot find "//infn//". Please execute 'hbsprescan' again" )
      bye
    }
  }
  
#----- Scanning the list file

  for( i=1; i<=4; i+=1 )
  {

    infn = "hbsprescan."//i

    curfit( infn, function="legendre", weighting="uniform",\
            order=6, interactive+, axis=1, listdata-, ver-,\
	    calctype="double", power+, device="stdgraph", cursor="",\
	    > tmp_tbl )

    list = tmp_tbl

    while( fscan( list, buf, buf1, buf2, buf3, buf4, buf5,\
                  buf6, buf7 ) != EOF )
    {
      if( strlen( buf ) != 1 )
        next
      j = int( buf )
      if( j > 0 )
      {
        c[j] = real( buf1 )
      }
    }

    printf( "%12.9e %12.9e %12.9e %12.9e %12.9e %12.9e\n",\
            c[1], c[2], c[3], c[4], c[5], c[6], >> outfn )

    delete( tmp_tbl, ver- )

  }
  
end
